\chapter{Expected behaviour}

\section{Jump instructions}
The jump instructions wherever possible are executed inside the instruction queue (See \autoref{subsubsec:instr_queue_second}). For some kind of jumps this isn't possible so they are executed in the datapath and have some delay aka \emph{jump delay slots}. The delays are listed in the table below.

\begin{table}[H]
	\centering
	\begin{tabular}{|l|r|}
		\hline
		Jump instruction & Branch delay slots \\
		\hline
		J & 0 \\
		\hline
		JAL & 0 \\
		\hline
		JR & 2 \\
		\hline
		BNEQ & 2 \\
		\hline
		BEQZ & 2 \\
		\hline
	\end{tabular}
	\label{tab:branch_delay_slots}
\end{table}

\subsection{J and JAL}
This two instruction are executed at fetch time. To simplify this phase the instructions are stored in couples but this can lead to some performances loss when executing the jump. In fact if the destination instruction is in the second slot of the couple the first instruction will be issued anyway an has to be executed, the jump will be managed immediately and should not be issued so it is overwritten with a nop. In this case, one clock cycle is lost if the queue has the destination instruction, otherwise the CPU has to wait for the IRAM and the pipeline will be stalled waiting for the memory. Another particular case is the JAL: it has exactly the same behaviour of the J but needs to write the PC+8 to the last register R31. The address will be written at the decode phase of the instruction which substituted the JAL in the queue ( from an assembly point of view is the first instruction after the JAL). I've decided to keep the original behaviour so the output value is PC+8, but it should be PC+12. The "+8" is for the jump back (with JR) and avoid the branch delay slot which is one in the original DLX implementation, using a "+12" in my design is more logical. My intention was to move the branch unit to the decode phase but due to the increased complexity, considering the other added units too, I've decided to keep it at the execute stage. I advice to add "+4" to R31 before doing a JR after a JAL to avoid the second branch delay slot. 

\section{External memories considerations}
Real memories are usually slower than the CPU frequency so interfacing with them causes delays. The two memories provided have settable delay which by default is two clock cycles. When writing the control unit, the static delays have not been considered but the ready/valid signals from the memories are used. The cache provided have not been used since I've preferred to focus on the other features. Due to this some changes related to the reading/writing bus have been necessary for the DRAM. In the original VHDL files the DRAM writes/reads two words at each operation and the single operations, one word read/write, were delegated to the cache. The data bus in the DRAM has been reduced, allowing one word write (and read). Using the default settings we should expect two clock cycles delay for each read or write operation and consecutive data transfers are allowed.

\section{IRAM addressable space}
By specifications each instruction is 32 bits long, \(4*8 bits\), so two consecutive instructions have a difference of four in their addresses. The provided IRAM is filled with the raw bits given by the compiler and two consecutive instructions have consecutive addresses with difference one. Considering that accessing addresses which are not multiple of four is not allowed (unaligned memory access to the IRAM is usually an error), the new program counter (read as new IRAM address to read) is divided by four (shift by two to the right) and then sent as address. The line responsible for this is in the instruction queue and can be seen in \autoref{lst:instr_queue_addr_out}. Because of that the available addresses are \(2^{30}\).
\inputvhdl{a.a-CU.core/a.a.c-instr_queue.vhd}{56}{56}{1}{}{lst:instr_queue_addr_out}

\section{Unsigned instructions}
From the specification, signed instructions should give an exception if the overflow is triggered by the ALU contrary to the unsigned instructions. The immediate unit have been written to extend the sign only if requested as described in \autoref{subsec:imm} but if both operands are registers the ALU performs exactly the same operation both for the signed and unsigned instructions, like \emph{add} and \emph{addu}. The overflow signal should be ignored by the control unit if an unsigned operation is performed and should be managed if it is generated by a signed one. Since no exception mechanism has been included in the design we have the following behaviour:
\begin{itemize}
	\item Immediate-Register operation: the immediate unit does not extend the sign in case of unsigned instruction, the ALU performs the operation with different operands depending on the operation variant (u or not u), \textbf{overflow is generated by the ALU and ignored by the CU}
	\item Register-Register operation: the ALU performs the same operation on the same operands so the result is equal for both variants of the instruction, \textbf{overflow is generated by the ALU and ignored by the CU}

\end{itemize}
